PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package serverobject
  Definition Classes
    objects
-  package turret
  Definition Classes
    serverobject
- FacilityTurret
- FacilityTurretControl
- FacilityTurretDefinition
- TurretAmmoBox
- TurretDefinition
- TurretUpgrade
- TurretWeapon
- WeaponTurret
- WeaponTurrets

c

net.psforever.objects.serverobject.turret

# FacilityTurret

###
Companion object FacilityTurret

#### class FacilityTurret extends Amenity with WeaponTurret with JammableUnit with CaptureTerminalAware

Source
  FacilityTurret.scala

Linear Supertypes
CaptureTerminalAware, JammableUnit, WeaponTurret, Container, MountableWeapons, Mountable, MountedWeapons, Amenity, StandardResistanceProfile, ResistanceProfile, Vitality, VitalsHistory, PlanetSideServerObject, ZoneAware, FactionAffinity, PlanetSideGameObject, WorldEntity, IdentifiableEntity, Identifiable, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. FacilityTurret
2. CaptureTerminalAware
3. JammableUnit
4. WeaponTurret
5. Container
6. MountableWeapons
7. Mountable
8. MountedWeapons
9. Amenity
10. StandardResistanceProfile
11. ResistanceProfile
12. Vitality
13. VitalsHistory
14. PlanetSideServerObject
15. ZoneAware
16. FactionAffinity
17. PlanetSideGameObject
18. WorldEntity
19. IdentifiableEntity
20. Identifiable
21. AnyRef
22. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new FacilityTurret(tDef: FacilityTurretDefinition)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def Actor: ActorRef

   Retrieve a reference to the internal `Actor`.

   Retrieve a reference to the internal `Actor`.

   returns

     the internal `ActorRef`

   Definition Classes
     PlanetSideServerObject
5.  def Actor_=(control: ActorRef): ActorRef

   Assign an `Actor` to act for this server object.

   Assign an `Actor` to act for this server object. This reference is only set once, that is, as long as the internal `ActorRef` directs to `ActorRef.noSender` (`null`).

   control

     the `Actor` whose functionality will govern this server object

   returns

     the current internal `ActorRef`

   Definition Classes
     PlanetSideServerObject
6.  def CanDamage: Boolean
   Definition Classes
     Vitality
7.  def CanRepair: Boolean
   Definition Classes
     Vitality
8.  def ClearHistory(): List[VitalsActivity]
   Definition Classes
     VitalsHistory
9.  def Collisions(index: Int, width: Int, height: Int): Try[List[InventoryItem]]

   Given a region of "searchable unit positions" considered as stowable, determine if any previously stowed items are contained within that region.
   Default usage, and recommended the continued inclusion of that use, is defined in terms of `Equipment` being stowed in a `GridInventory`.

   Given a region of "searchable unit positions" considered as stowable, determine if any previously stowed items are contained within that region.
   Default usage, and recommended the continued inclusion of that use, is defined in terms of `Equipment` being stowed in a `GridInventory`. Where the `Equipment` object is defined by the dimensions `width` and `height`, starting a search at `index` will search all positions within a grid-like range of numbers. Under certain searching conditions, this range may be meaningless, such as is the case when searching individual positions that are normal `EquipmentSlot` objects. Regardless, the value collected indicates the potential of multiple objects being discovered and maintains a reference to the object itself and the slot position where the object is located. (As any object can be discovered within the range, that is important.)

   index

     the position to start searching

   width

     the width of the searchable space

   height

     the height of the serachable space

   returns

     a list of objects that have been encountered within the searchable space

   Definition Classes
     Container
   See also

     `GridInventory.CheckCollisionsVar`

10.  def ConfirmUpgrade(upgrade: TurretUpgrade.Value): TurretUpgrade.Value
    Definition Classes
      WeaponTurret
11.  def Continent: String
    Definition Classes
      ZoneAware
12.  def Continent_=(zoneId: String): String

    Give the entity a custom `Zone` identifier.

    Give the entity a custom `Zone` identifier.

    zoneId

      the custom identifier of the `Zone` object

    returns

      the identifier of the `Zone` object

    Definition Classes
      ZoneAware
13.  def ControlledWeapon(wepNumber: Int): Option[Equipment]
    Definition Classes
      MountableWeapons
14.  def DamageModel: DamageAndResistance
    Definition Classes
      Amenity → Vitality
15.  def DefaultHealth: Int
    Definition Classes
      Vitality
16.  def Definition: FacilityTurretDefinition
    Definition Classes
      FacilityTurret → WeaponTurret → MountableWeapons → Mountable → MountedWeapons → Amenity → Vitality → PlanetSideGameObject
17.  def Destroyed: Boolean
    Definition Classes
      PlanetSideGameObject
18.  def Destroyed_=(state: Boolean): Boolean
    Definition Classes
      PlanetSideGameObject
19.  def Entity: WorldEntity
    Definition Classes
      PlanetSideGameObject
20.  def Entity_=(newEntity: WorldEntity): Unit
    Definition Classes
      PlanetSideGameObject
21.  def Faction: types.PlanetSideEmpire.Value
    Definition Classes
      Amenity → FactionAffinity
22.  def Faction_=(fac: types.PlanetSideEmpire.Value): types.PlanetSideEmpire.Value
    Definition Classes
      FactionAffinity
23.  def Find(guid: PlanetSideGUID): Option[Int]

    Given globally unique identifier, if the object using it is stowed, attempt to locate its slot.

    Given globally unique identifier, if the object using it is stowed, attempt to locate its slot. All positions, `VisibleSlot` and `Inventory`, and wherever else, should be searchable.

    guid

      the GUID of the `Equipment`

    returns

      the index of the `EquipmentSlot`, or `None`

    Definition Classes
      Container
24.  def Find(obj: Equipment): Option[Int]

    Given an object, attempt to locate its slot.

    Given an object, attempt to locate its slot. All positions, `VisibleSlot` and `Inventory`, and wherever else, should be searchable.

    obj

      the `Equipment` object

    returns

      the index of the `EquipmentSlot`, or `None`

    Definition Classes
      Container
25.  def Fit(tile: InventoryTile): Option[Int]
    Definition Classes
      Container
26.  def Fit(obj: Equipment): Option[Int]
    Definition Classes
      Container
27.  def GUID: PlanetSideGUID
    Definition Classes
      IdentifiableEntity → Identifiable
28.  def GUID_=(guid: PlanetSideGUID): PlanetSideGUID
    Definition Classes
      IdentifiableEntity → Identifiable
29.  def GUID_=(guid: StalePlanetSideGUID): PlanetSideGUID

    Always intercept `StalePlanetSideGUID` references when attempting to mutate the GUID value.

    Always intercept `StalePlanetSideGUID` references when attempting to mutate the GUID value.

    guid

      the valid GUID to assign

    returns

      never returns

    Definition Classes
      IdentifiableEntity
    Exceptions thrown

      ``AssigningGUIDException`` always

30.  def GetSeatFromMountPoint(mountPoint: Int): Option[Int]

    Given a mount point index, return the associated mount index.

    Given a mount point index, return the associated mount index.

    mountPoint

      the mount point

    returns

      the mount index

    Definition Classes
      Mountable
31.  def HasGUID: Boolean

    Flag when the object has no GUID (initial condition) or is considered stale.

    Flag when the object has no GUID (initial condition) or is considered stale.

    returns

      whether the value of the GUID is a valid representation for this object

    Definition Classes
      IdentifiableEntity
32.  def Health: Int
    Definition Classes
      Vitality
33.  def Health_=(assignHealth: Int): Int
    Definition Classes
      Vitality
34.  def History(result: DamageResult): List[VitalsActivity]

    Very common example of a `VitalsActivity` event involving damage.

    Very common example of a `VitalsActivity` event involving damage.

    result

      the fully-informed entry

    returns

      the list of previous changes to this object's vital statistics

    Definition Classes
      VitalsHistory
35.  def History(action: Option[VitalsActivity]): List[VitalsActivity]

    A `VitalsActivity` event must be recorded.

    A `VitalsActivity` event must be recorded. Add new entry to the front of the list (for recent activity).

    action

      the fully-informed entry

    returns

      the list of previous changes to this object's vital statistics

    Definition Classes
      VitalsHistory
36.  def History(action: VitalsActivity): List[VitalsActivity]

    A `VitalsActivity` event must be recorded.

    A `VitalsActivity` event must be recorded. Add new entry to the front of the list (for recent activity).

    action

      the fully-informed entry

    returns

      the list of previous changes to this object's vital statistics

    Definition Classes
      VitalsHistory
37.  def History: List[VitalsActivity]
    Definition Classes
      VitalsHistory
38.  def Invalidate(): Unit

    Indicate that the current GUID is no longer a valid representation of the object.

    Indicate that the current GUID is no longer a valid representation of the object. Transforms whatever the current GUID is into a `StalePlanetSideGUID` entity with the same value. Doing this restores the object to its default mutation option ("the ability to set a new valid GUID"). The current GUID will still be accessed as if it were valid, but it will be wrapped in the new stale object.

    Definition Classes
      IdentifiableEntity
39.  def Inventory: GridInventory

    A(n imperfect) reference to a generalized pool of the contained objects.

    A(n imperfect) reference to a generalized pool of the contained objects. Having access to all of the available positions is not required. The entries in this reference should definitely include all unseen positions. The `GridInventory` returned by this accessor is also an implementation of `Container`.

    Definition Classes
      WeaponTurret → Container
    See also

      `VisibleSlots`

40.  def Jammed: Boolean
    Definition Classes
      JammableUnit
41.  def Jammed_=(state: Boolean): Boolean
    Definition Classes
      JammableUnit
42.  def LastDamage: Option[DamageResult]
    Definition Classes
      VitalsHistory
43.  def LastShot: Option[DamageResult]

    Find, specifically, the last instance of a weapon discharge vital statistics change.

    Find, specifically, the last instance of a weapon discharge vital statistics change.

    returns

      information about the discharge

    Definition Classes
      VitalsHistory
44.  def LocationOffset: Vector3
    Definition Classes
      Amenity
45.  def LocationOffset_=(off: Option[Vector3]): Vector3
    Definition Classes
      Amenity
46.  def LocationOffset_=(off: Vector3): Vector3
    Definition Classes
      Amenity
47.  def MaxHealth: Int
    Definition Classes
      Vitality
48.  def MaxHealth_=(default: Option[Int]): Int
    Definition Classes
      Vitality
49.  def MaxHealth_=(default: Int): Int
    Definition Classes
      Vitality
50.  def MountPoints: Map[Int, MountInfo]

    Retrieve a mapping of each mount from its mount point index.

    Retrieve a mapping of each mount from its mount point index.

    returns

      the mapping of mount point to mount

    Definition Classes
      Mountable
51.  def Orientation: Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
52.  def Orientation_=(vec: Vector3): Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
53.  def Owner: AmenityOwner

    Reference the object that is in direct association with (is superior to) this one.

    Reference the object that is in direct association with (is superior to) this one.

    returns

      the object associated as this object's "owner"

    Definition Classes
      Amenity
54.  def Owner_=(obj: AmenityOwner): AmenityOwner

    Set an object to have a direct association with (be superior to) this one.

    Set an object to have a direct association with (be superior to) this one.

    obj

      the object trying to become associated as this object's "owner"

    returns

      the object associated as this object's "owner"

    Definition Classes
      Amenity
    See also

      `Amenity.AmenityTarget`

55.  def PassengerInSeat(user: Player): Option[Int]

    Given a player, determine if that player is seated.

    Given a player, determine if that player is seated.

    user

      the player

    returns

      the mount index

    Definition Classes
      Mountable
56.  def Position: Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
57.  def Position_=(vec: Vector3): Vector3
    Definition Classes
      PlanetSideGameObject → WorldEntity
58.  def RadiationShielding: Float
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
59.  def ResetControl(): ActorRef
    Definition Classes
      PlanetSideServerObject
60.  def Resist(dtype: vital.base.DamageType.Value): Float
    Definition Classes
      ResistanceProfile
61.  def ResistanceAggravated: Int
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
62.  def ResistanceDirectHit: Int
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
63.  def ResistanceSplash: Int
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
64.  def Seat(seatNumber: Int): Option[Seat]

    Given a mount's index position, retrieve the internal `Seat` object.

    Given a mount's index position, retrieve the internal `Seat` object.

    returns

      the specific mount

    Definition Classes
      Mountable
65.  def Seats: Map[Int, Seat]

    Retrieve a mapping of each mount from its internal index.

    Retrieve a mapping of each mount from its internal index.

    returns

      the mapping of index to mount

    Definition Classes
      Mountable
66.  def Slot(slotNum: Int): EquipmentSlot

    Access to all stowable positions on this object by index.
    All positions, `VisibleSlot` and `Inventory`, and wherever else, should be reachable.

    Access to all stowable positions on this object by index.
    All positions, `VisibleSlot` and `Inventory`, and wherever else, should be reachable. Regardless of the internal storage medium, the format of return is expected to be the same structure of object as the most basic storage component for `Equipment`, namely, `EquipmentSlot` objects. By default, it is expected to return an `EquipmentSlot` that can not be manipulated because it is `Blocked`.

    slotNum

      an index

    returns

      the searchable position identified by that index

    Definition Classes
      Container
    See also

      `OffhandEquipmentSlot`

67.  def Subtract: DamageProfile
    Definition Classes
      StandardResistanceProfile → ResistanceProfile
68.  def Upgrade: TurretUpgrade.Value
    Definition Classes
      WeaponTurret
69.  def Upgrade_=(upgrade: TurretUpgrade.Value): TurretUpgrade.Value
    Definition Classes
      WeaponTurret
70.  def Velocity: Option[Vector3]
    Definition Classes
      PlanetSideGameObject → WorldEntity
71.  def Velocity_=(vec: Option[Vector3]): Option[Vector3]
    Definition Classes
      PlanetSideGameObject → WorldEntity
72.  def Velocity_=(vec: Vector3): Option[Vector3]
    Definition Classes
      WorldEntity
73.  def VisibleSlots: Set[Int]

    A(n imperfect) reference to a generalized pool of the contained objects.
    Having access to all of the available positions is not required.

    A(n imperfect) reference to a generalized pool of the contained objects.
    Having access to all of the available positions is not required. Only the positions that can be actively viewed by other clients are listed.

    returns

      all of the affected slot indices

    Definition Classes
      WeaponTurret → Container
    See also

      `Inventory`

74.  def WeaponControlledFromSeat(seatNumber: Int): Option[Equipment]

    Given a valid mount number, retrieve an index where the weapon controlled from this mount is mounted.

    Given a valid mount number, retrieve an index where the weapon controlled from this mount is mounted.

    seatNumber

      the mount number

    returns

      a mounted weapon by index, or `None` if either the mount doesn't exist or there is no controlled weapon

    Definition Classes
      MountableWeapons
75.  def Weapons: Map[Int, EquipmentSlot]
    Definition Classes
      MountedWeapons
76.  def Zone: Zone
    Definition Classes
      Amenity → ZoneAware
77.  def Zone_=(zone: Zone): Zone

    When assigning a new `Zone` object for the `Vehicle` object, eliminate

    When assigning a new `Zone` object for the `Vehicle` object, eliminate

    zone

      a reference to the `Zone` object

    returns

      a reference to the `Zone` object

    Definition Classes
      ZoneAware
78.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
79.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
80.  def controlledWeapon(wepNumber: Int): Option[Equipment]
    Definition Classes
      MountableWeapons
81.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
82.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
83.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
84.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
85.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
86.  val inventory: GridInventory

    may or may not have inaccessible inventory space see `ReserveAmmunition` in the definition

    may or may not have inaccessible inventory space see `ReserveAmmunition` in the definition

    Attributes
      protected
    Definition Classes
      WeaponTurret
87.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
88.  def isMoving(test: Float): Boolean

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    test

      the (squared) velocity to test against

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
89.  def isMoving(test: Vector3): Boolean

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    This object is not considered moving unless it is moving at least as fast as a certain velocity.

    test

      the velocity to test against

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
90.  def isMoving: Boolean

    A velocity of non-zero is the same as moving.

    A velocity of non-zero is the same as moving.

    returns

      `true`, if we are moving; `false`, otherwise

    Definition Classes
      WorldEntity
91.  def isUpgrading: Boolean
    Definition Classes
      WeaponTurret
92.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
93.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
94.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
95.  val seats: Map[Int, Seat]
    Attributes
      protected
    Definition Classes
      Mountable
96.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
97.  def toString(): String
    Definition Classes
      AnyRef → Any
98.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
99.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
100.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException]) @native()
101.  val weapons: Map[Int, EquipmentSlot]
     Attributes
       protected
     Definition Classes
       MountedWeapons

### Inherited from CaptureTerminalAware

### Inherited from JammableUnit

### Inherited from WeaponTurret

### Inherited from Container

### Inherited from MountableWeapons

### Inherited from Mountable

### Inherited from MountedWeapons

### Inherited from Amenity

### Inherited from StandardResistanceProfile

### Inherited from ResistanceProfile

### Inherited from Vitality

### Inherited from VitalsHistory

### Inherited from PlanetSideServerObject

### Inherited from ZoneAware

### Inherited from FactionAffinity

### Inherited from PlanetSideGameObject

### Inherited from WorldEntity

### Inherited from IdentifiableEntity

### Inherited from Identifiable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped